import { Connection } from '@solana/web3.js';
import { AccountAddress, ChainAddress, ChainsConfig, CircleBridge, CircleTransferMessage, Contracts, Network, Platform } from '@wormhole-foundation/connect-sdk';
import { Program } from '@project-serum/anchor';
import { SolanaChains, SolanaPlatformType, SolanaUnsignedTransaction } from '@wormhole-foundation/connect-sdk-solana';
import { MessageTransmitter } from './messageTransmitter';
import { TokenMessenger } from './tokenMessenger';
export declare class SolanaCircleBridge<N extends Network, C extends SolanaChains> implements CircleBridge<N, SolanaPlatformType, C> {
    readonly network: N;
    readonly chain: C;
    readonly connection: Connection;
    readonly contracts: Contracts;
    readonly tokenMessenger: Program<TokenMessenger>;
    readonly messageTransmitter: Program<MessageTransmitter>;
    private constructor();
    static fromRpc<N extends Network>(provider: Connection, config: ChainsConfig<N, Platform>): Promise<SolanaCircleBridge<N, SolanaChains>>;
    redeem(sender: AccountAddress<C>, message: string, attestation: string): AsyncGenerator<SolanaUnsignedTransaction<N, C>>;
    transfer(sender: AccountAddress<C>, recipient: ChainAddress, amount: bigint): AsyncGenerator<SolanaUnsignedTransaction<N, C>>;
    parseTransactionDetails(txid: string): Promise<CircleTransferMessage>;
    private createUnsignedTx;
}
//# sourceMappingURL=circleBridge.d.ts.map